<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { FreeTrialHero } from '~/components/free-trial/index.vue';

export default Vue.extend({
  name: 'FreeTrial',
  components: {
    FreeTrialHero,
  },
  layout: 'free-trial-navigation',
  async asyncData({ $content, i18n, $freeTrialService }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;

      if (!locale) {
        const content =
          await $freeTrialService.getContent(`free-trial/devsecops`);

        // This needs to be refactored to avoid accesing number-indexed arrays
        // We should create a new service under /services/free-trial/devsecops.service.ts
        return {
          doc: {
            ...content,
            hero: {
              ...content.components[0].data,
              default: content.components[0].data.default,
              smb: content.components[1].data.smb,
              ci: content.components[2].data.ci,
              security: content.components[3].data.security,
            },
            g2_categories: content.components[4].data,
            information_squares: content.components[5].data.information_squares,
            next_steps: content.components[6].data,
          },
        };
      }

      const doc = await $content(locale, `free-trial/devsecops`).fetch();

      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div>
    <FreeTrialHero
      :data="doc?.hero"
      :button-text="doc?.hero.repeated_button_text || doc?.repeated_button_text"
    />
    <section class="accolades-wrapper">
      <SlpContainer>
        <div class="flex">
          <div class="content">
            <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-8">
              {{ doc.g2_categories.header }}
            </SlpTypography>
            <SlpTypography tag="p" variant="heading4" class="slp-mb-24">
              {{ doc.g2_categories.subtitle }}
            </SlpTypography>
            <SlpButton
              href="https://gitlab.com/-/trial_registrations/new"
              variant="secondary"
              :data-ga-name="doc.g2_categories.data_ga_name"
              :data-ga-location="doc.g2_categories.data_ga_location"
            >
              {{ doc.hero.repeated_button_text || doc?.repeated_button_text }}
              <SlpIcon
                class="learn-more-icon slp-ml-8"
                name="chevron-lg-right"
                variant="product"
              />
            </SlpButton>
          </div>
          <div class="badges">
            <img
              v-for="badge in doc.g2_categories.badges"
              :key="badge.src"
              width="95px"
              :alt="badge.alt"
              :src="badge.src"
            />
          </div>
        </div>
      </SlpContainer>
    </section>
    <section>
      <SlpContainer>
        <div class="content-cards">
          <div
            v-for="card in doc.information_squares"
            :key="card.icon"
            class="content-card"
          >
            <img
              v-if="card.icon_src"
              class="icon"
              :src="card.icon_src"
              aria-hidden="true"
              alt=""
            />
            <SlpIcon
              v-else
              :icon="card.icon"
              size="lg"
              class="slp-mb-16"
              color="accent-500"
            />
            <SlpTypography tag="h3" variant="heading3-bold" class="slp-mb-16">
              {{ card.heading }}
            </SlpTypography>
            <SlpTypography variant="body2" tag="p">
              {{ card.text }}
            </SlpTypography>
          </div>
        </div>
      </SlpContainer>
    </section>
    <section class="next-steps">
      <SlpContainer>
        <SlpTypography variant="heading2-bold" tag="h2">
          {{ doc.next_steps.heading }}
        </SlpTypography>
        <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-16">
          {{ doc.next_steps.subtitle }}
        </SlpTypography>
        <SlpTypography variant="heading4" tag="p" class="slp-mb-24">
          {{ doc.next_steps.text }}
        </SlpTypography>
        <SlpButton
          href="https://gitlab.com/-/trial_registrations/new"
          variant="primary"
          data-ga-name="free trial"
          data-ga-location="feature"
        >
          {{ doc.next_steps.cta_text || doc.hero?.repeated_button_text }}
          <SlpIcon
            class="learn-more-icon slp-ml-8"
            name="chevron-lg-right"
            variant="product"
          />
        </SlpButton>
      </SlpContainer>
    </section>
  </div>
</template>

<style lang="scss" scoped>
.slp-btn {
  @media (max-width: $breakpoint-md) {
    width: 100%;
    justify-content: center;
  }
}
.flex {
  display: flex;

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
  }
}

.accolades-wrapper {
  padding: $spacing-96 0;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }
}

.accolades-wrapper {
  background: $color-surface-700;
  color: $color-text-50;
}

.next-steps {
  padding: $spacing-96 0;
  background: radial-gradient(
      50.08% 44.51% at 100% 100%,
      rgba(169, 137, 245, 0.2) 0,
      rgba(119, 89, 194, 0) 100%
    ),
    radial-gradient(
      60.76% 48.01% at 0 100%,
      rgba(226, 67, 41, 0.2) 0,
      rgba(226, 67, 41, 0) 100%
    ),
    #fff;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }
}

.content-cards {
  display: flex;
  flex-wrap: wrap;
  padding: $spacing-96 0;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }

  .content-card {
    padding: $spacing-32 40px 40px 40px;
    flex: 1 0 45%;

    .icon {
      width: 48px;
      height: 48px;
    }

    @media (max-width: $breakpoint-md) {
      padding: $spacing-32 0;
      flex: 1 0 100%;

      &:not(:last-of-type) {
        border-bottom: 1px solid $color-surface-200;
      }
    }

    @media (min-width: $breakpoint-lg) {
      &:nth-of-type(1),
      &:nth-of-type(3) {
        border-right: 1px solid $color-surface-200;
      }

      &:nth-of-type(3),
      &:nth-of-type(4),
      &:last-of-type {
        border-top: 1px solid $color-surface-200;
      }
    }
  }
}

.badges {
  display: flex;
  flex: 1 0 50%;
  flex-wrap: wrap;
  gap: 42px;
  justify-content: flex-end;
  position: relative;

  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-32;
    justify-content: flex-start;
    gap: 32px;
  }
}
</style>
